﻿unit u_edita_cc_nb_movimentos;

{$mode objfpc}{$H+}

interface

uses
  Graphics, Classes, SysUtils, DB, SQLDB, Forms, Controls,
  Dialogs, DBGrids, DBCtrls, Buttons, StdCtrls, Grids, ExtCtrls, MaskEdit,
  u_prep_query_cc_nb_movimentos, LCLType, IniFiles; //, u_dm_movimentos;

type


  { Tfrm_edita_cc_nb_movimentos }

  Tfrm_edita_cc_nb_movimentos = class(TForm)
    B_pesquisa_livre_Rollback: TButton;
    B_sai_pesquisa_livre: TButton;
    B_executa_pesquisa_livre: TButton;
    B_pesquisa_livre: TButton;
    B_rollback: TButton;
    DBE_total_movimentos: TDBEdit;
    DBE_credito: TDBEdit;
    DBE_debito: TDBEdit;
    DBLCB_tipo_movimento: TDBLookupComboBox;
    DBG_movimentos_cc_nb: TDBGrid;
    DBLCB_analisado: TDBLookupComboBox;
    DBN_movimentos_cc_nb: TDBNavigator;
    E_que_cartao: TEdit;
    E_Saldo: TEdit;
    GB_pesquisa_livre: TGroupBox;
    IL_movimentos: TImageList;
    L_Saldo: TLabel;
    L_num_movimentos: TLabel;
    L_titulo: TLabel;
    M_pesquisa_livre: TMemo;
    SB_Exit: TSpeedButton;
    SB_PrepQuery: TSpeedButton;
    SB_Inverte_a_Ordem: TSpeedButton;
    procedure B_pesquisa_livre_RollbackClick(Sender: TObject);
    procedure B_executa_pesquisa_livreClick(Sender: TObject);
    procedure B_pesquisa_livreClick(Sender: TObject);
    procedure B_rollbackClick(Sender: TObject);
    procedure B_sai_pesquisa_livreClick(Sender: TObject);
    procedure DBG_movimentos_cc_nbColExit(Sender: TObject);
    procedure DBG_movimentos_cc_nbDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DBG_movimentos_cc_nbDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBG_movimentosKeyPress(Sender: TObject; var Key: char);
    procedure DBG_movimentos_cc_nbTitleClick(Column: TColumn);
    procedure DBLCB_tipo_movimentoUTF8KeyPress(Sender: TObject;
      var UTF8Key: TUTF8Char);
    procedure DBN_movimentos_cc_nbClick(Sender: TObject; Button: TDBNavButtonType);
    procedure E_que_cartaoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormShow(Sender: TObject);
    procedure SB_ExitClick(Sender: TObject);
    procedure SB_Inverte_a_OrdemClick(Sender: TObject);
    procedure SB_PrepQueryClick(Sender: TObject);

  private

  public
    que_cartao: string;

  end;

var
  frm_edita_cc_nb_movimentos: Tfrm_edita_cc_nb_movimentos;
  clausula_where,
  SQL_text: string;

  op_PK_movimento,
  op_data_mov,
  op_data_val,
  op_descricao,
  op_debito,
  op_credito,
  op_saldo_controlo,
  op_tipo,
  op_cod_tipo_movimento,
  op_analisado: string;

  ord_pk_movimentos_nb: string = 'ASC';
  ord_estado: string = 'ASC';
  ord_nome_comercio: string = 'ASC';
  ord_desc_factura: string = 'ASC';
  ord_taxas_comissoes: string = 'ASC';
  ord_montante: string = 'ASC';
  ord_moeda_debito: string = 'ASC';
  ord_montante_moeda_orig: string = 'ASC';
  ord_moeda_origem: string = 'ASC';
  ord_analisado: string = 'ASC';
  ord_cartao: string = 'ASC';
  ord_cod_tipo_movimento: string = 'ASC';
  ord_notas: string = 'ASC';

  Ordem_Movimentos: string = 'ASC';

//  que_cartao: string;     movida para public
implementation
  uses u_dm_movimentos;

{$R *.frm}

{ Tfrm_edita_cc_nb_movimentos }
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.DBN_movimentos_cc_nbClick(Sender: TObject; Button: TDBNavButtonType);
var
  BtnName: string;
begin
  case Button of
    nbFirst  : BtnName := 'nbFirst';
    nbPrior  : BtnName := 'nbPrior';
//    nbNext   : BtnName := 'nbNext';
    nbNext   : begin
               try
                 case frm_dm_movimentos.SQLQ_cartoes_NB.UpdateStatus of    //deteta alterações aos dados em SQLQ_cartoes_cc_NB
//                    usUnmodified : ShowMessage('Unmodified');
                      usModified   : begin                            // ensaios vários. inconsequentes
//                                       showmessage('modifi9ado');
                                      end;
                      usInserted   : ShowMessage('Inserted');
                      usDeleted    : ShowMessage('Deleted');
                 end;

               except
               on E: Exception do
               begin
                 MessageDlg('Error', 'Problema acedendo ao registo seguinte. Mensagem técnica do erro: ' + E.Message, mterror, [mbOK], 0);
               end;
               end;

               end;

    nbLast   : BtnName := 'nbLast';
    nbInsert : BtnName := 'nbInsert';
    nbDelete : BtnName := 'nbDelete';
    nbEdit   : BtnName := 'nbEdit';
    nbPost   : begin
                 try
                   frm_dm_movimentos.SQLQ_cartoes_NB.Open;
                   frm_dm_movimentos.SQLQ_cartoes_NB.Edit;
                   frm_dm_movimentos.SQLQ_cartoes_NB.UpdateMode := upWhereAll;
                   frm_dm_movimentos.SQLQ_cartoes_NB.ApplyUpdates;
//                   SQLT_Movimentos.Commit;
                   frm_dm_movimentos.SQLQ_cartoes_NB.Open;

//                   SQLQ_cartoes_NB.Refresh;

                 except
                   on E: Exception do
                   begin
                     MessageDlg('Error', 'Problema com Post/Update. Mensagem técnica do erro: ' + E.Message, mterror, [mbOK], 0);
                   end;
                  end;
               end;
    nbCancel : BtnName := 'nbCancel';
    nbRefresh: BtnName := 'nbRefresh';
  end;

  if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
     frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;   // refresca a contagem do total de movimentos na BD

  if frm_dm_movimentos.SQLQ_totais_debito_credito_nb.Active = FALSE then
     frm_dm_movimentos.SQLQ_totais_debito_credito_nb.Active := TRUE;   // refresca a determinação dos totais das colunas  debito e credito na BD
end;

procedure Tfrm_edita_cc_nb_movimentos.E_que_cartaoClick(Sender: TObject);
begin
  if que_cartao = 'Catarina' then
  begin
    que_cartao := 'João';
    E_que_cartao.Color := $0012C1ED;
    E_que_cartao.Font.Size := 11;
    E_que_cartao.Font.Color := clBlack;
    E_que_cartao.Font.Style := [fsBold];


//    frm_dm_movimentos.SQLQ_cartoes_cc_NB.Active := FALSE;
    frm_dm_movimentos.SQLQ_cartoes_NB.Close;
    frm_dm_movimentos.SQLQ_cartoes_NB.SQL.Text := 'SELECT * FROM sch_conta.movimentos_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39) + ' ORDER BY estado ASC';   // estado=data
    frm_edita_cc_nb_movimentos.Caption := frm_edita_cc_nb_movimentos.Caption + que_cartao;
    frm_edita_cc_nb_movimentos.l_Titulo.Caption := 'Controle dos movimentos da conta  NB  (' + que_cartao + ')';
    E_que_cartao.Text := 'Conta activa:  ' + que_cartao + '.  Clique para aceder ao outro cartão!';
//    frm_dm_movimentos.SQLQ_movimentos_nb.Active := TRUE;
    frm_dm_movimentos.SQLQ_movimentos_nb.Open;
//    frm_dm_movimentos.SQLQ_movimentos_nb.Refresh;

//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := FALSE;
    frm_dm_movimentos.SQLQ_total_movimentos_NB.Close;
    frm_dm_movimentos.SQLQ_total_movimentos_NB.SQL.Text := 'SELECT COUNT(*) as Total_Registos FROM sch_conta.movimentos_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39) + ' GROUP BY cartao';
//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;
    frm_dm_movimentos.SQLQ_total_movimentos_NB.Open;
//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Refresh;

//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := FALSE;
    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Close;
    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.SQL.Text := 'SELECT debito, credito, conta FROM sch_conta.v_totais_deve_haver_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39);

//    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Active := TRUE;
    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Open;
//    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Refresh;
  end
  else
  if que_cartao = 'João' then
  begin
    que_cartao := 'Catarina';
    E_que_cartao.Color := $00B4AE4B;
    E_que_cartao.Font.Size := 11;
    E_que_cartao.Font.Color := clCream;
    E_que_cartao.Font.Style := [fsBold];

//    frm_dm_movimentos.SQLQ_movimentos_nb.Active := FALSE;
    frm_dm_movimentos.SQLQ_movimentos_nb.Close;
    frm_dm_movimentos.SQLQ_movimentos_nb.SQL.Text := 'SELECT * FROM sch_conta.movimentos_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39) + ' ORDER BY estador ASC';  //estado=data
    frm_edita_cc_nb_movimentos.Caption := frm_edita_cc_nb_movimentos.Caption + '  '  + que_cartao;
    frm_edita_cc_nb_movimentos.l_Titulo.Caption := 'Controle dos movimentos da conta  NB  (' + que_cartao + ')';
    E_que_cartao.Text := 'Conta activa:  ' + que_cartao + '.  Clique para aceder ao outro cartão!';
//    frm_dm_movimentos.SQLQ_movimentos_nb.Active := TRUE;
    frm_dm_movimentos.SQLQ_movimentos_nb.Open;
//    frm_dm_movimentos.SQLQ_movimentos_nb.Refresh;

//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := FALSE;
    frm_dm_movimentos.SQLQ_total_movimentos_NB.Close;
    frm_dm_movimentos.SQLQ_total_movimentos_NB.SQL.Text := 'SELECT COUNT(*) as Total_Registos FROM sch_conta.movimentos_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39) + ' GROUP BY cartao';
//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;
    frm_dm_movimentos.SQLQ_total_movimentos_NB.Open;
//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Refresh;

//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := FALSE;
    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Close;
    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.SQL.Text := 'SELECT debito, credito, conta FROM sch_conta.v_totais_deve_haver_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39);
//    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Active := TRUE;
    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Open;
//    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Refresh;
  end;
end;

procedure Tfrm_edita_cc_nb_movimentos.DBG_movimentosKeyPress(Sender: TObject; var Key: char);
begin
  if (key = Chr(9)) then Exit;
  if (DBG_movimentos_cc_nb.SelectedField.FieldName = DBLCB_tipo_movimento.DataField) then
  begin
//    DBLCB_tipo_movimento.SetFocus;
//    SendMessage(DBLCB_tipo_movimento.Handle, WM_Char, word(Key), 0);    // aparentemente desnecessário
  end
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.DBG_movimentos_cc_nbTitleClick(Column: TColumn);
var
  i: integer;

begin
  with frm_dm_movimentos.SQLQ_cartoes_NB do
  begin
//
//    InputQuery('Complete s.f.f. a cláusula where', 'Complete s.f.f. a cláuslua where:', index);           // escreve o nome de cada coluna do grid
//    if index <> '' then
//       ShowMessage(DBG_movimentos_cc_nb.Columns[StrToInt(index)].FieldName);

//    InputQuery('Definição complementar das condições de pesquisa', 'Complete s.f.f. a cláuslua where:', c_where);
//    if c_where <> '' then
//    begin
//      c_where := 'where 1 = 1  ' + ' AND ' + c_where;
//    end;
//
    for i := 0 to DBG_movimentos_cc_nb.Columns.Count -1 do      // limpa os UP e DOWN dos títulos de todas as colunas antes de cada ordenação por qualquer coluna
    begin
      DBG_movimentos_cc_nb.Columns.Items[i].Title.ImageIndex := 2;
    end;;

    Close;
    SQL.Clear;
//                                  PK_MOVIMENTOS_CC_NB
    if column.FieldName = 'pk_movimentos_cc_nb' then
    begin
      if ord_pk_movimentos_nb = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by pk_movimentos_cc_nb ' + ' ASC');
        ord_pk_movimentos_nb := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by pk_movimentos_cc_nb ' + 'DESC');
        ord_pk_movimentos_nb := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
    //                                  ESTADO
    else if column.FieldName = 'estado' then
    begin
      if ord_estado = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by estado ' + 'ASC');    //estado=data
        ord_estado := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by estado ' + 'DESC');    //estado=data
        ord_estado := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  NOME_COMERCIO
    else if column.FieldName = 'nome_comercio' then
    begin
      if ord_nome_comercio = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by estado ' + 'ASC');    //estado=data
        ord_nome_comercio := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by estado ' + 'DESC');    //estado=data
        ord_nome_comercio := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  DESC_FACTURA
    else if column.FieldName = 'desc_factura' then
    begin
      if ord_desc_factura = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by desc_factura ' + 'ASC');
        ord_desc_factura := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by desc_factura ' + 'DESC');
        ord_desc_factura := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  TAXAS_COMISSOES
    else if column.FieldName = 'taxas_comissoes' then
    begin
      if ord_taxas_comissoes = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by taxas_comissoes ' + 'ASC');
        ord_taxas_comissoes := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by taxas_comissoes ' + 'DESC');
        ord_taxas_comissoes := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  MONTANTE
    else if column.FieldName = 'montante' then
    begin
      if ord_montante = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by coalesce(montante,0)::NUMERIC ' + 'ASC');
        ord_montante := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by coalesce(montante,0)::NUMERIC ' + 'DESC');
        ord_montante := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  MOEDA_DEBITO
    else if column.FieldName = 'moeda_debito' then
    begin
      if ord_moeda_debito = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb order by moeda_debito ' + 'ASC');
        ord_moeda_debito := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb order by moeda_debito ' + 'DESC');
        ord_moeda_debito := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  MONTANTE_MOEDA_ORIG
    else if column.FieldName = 'montante_moeda_orig' then
    begin
      if ord_montante_moeda_orig = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb order by coalesce(montante_moeda_orig,0)::NUMERIC ' + 'ASC');
        ord_montante_moeda_orig := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb order by coalesce(montante_moeda_orig,0)::NUMERIC ' + 'DESC');
        ord_montante_moeda_orig := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  MOEDA_ORIGEM
    else if column.FieldName = 'moeda_origem' then
    begin
      if ord_moeda_origem = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by moeda_origem ' + 'ASC');
        ord_moeda_origem := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by moeda_origem ' + 'DESC');
        ord_moeda_origem := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  ANALISADO
    else if column.FieldName = 'analisado' then
    begin
      if ord_analisado = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by analisado ' + 'ASC');
        ord_analisado := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by analisado ' + 'DESC');
        ord_analisado := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  COD_TIPO_MOVIMENTO
    else if column.FieldName = 'cod_tipo_movimento' then
    begin
      if ord_cod_tipo_movimento = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by coalesce(cod_tipo_movimento,0)::INTEGER ' + 'ASC');
        ord_cod_tipo_movimento := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by coalesce(cod_tipo_movimento,0)::INTEGER ' + 'DESC');
        ord_cod_tipo_movimento := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  CARTAO
        else if column.FieldName = 'cartao' then
        begin
          if ord_cartao = 'DESC' then
          begin
            SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by cartao ' + 'ASC');
            ord_cartao := 'ASC';
            column.Title.ImageIndex := 0;
          end
          else
          begin
            SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by cartao ' + 'DESC');
            ord_cartao := 'DESC';
            column.Title.ImageIndex := 1;
          end
        end
//                                  NOTAS
    else if column.FieldName = 'notas' then
    begin
      if ord_notas = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by notas ' + 'ASC');
        ord_notas := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by notas ' + 'DESC');
        ord_notas := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
    else
//    SQL.Add('select * from sch_conta.movimentos_nb where conta = ' + chr(39) + que_conta + chr(39) + ' order by pk_movimentos_nb ' + 'ASC');
      SQL.Add('select * from sch_conta.movimentos_cc_nb where cartao = ' + chr(39) + que_cartao + chr(39) + ' order by estado ' + 'ASC');
//
    Open;
  end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.DBLCB_tipo_movimentoUTF8KeyPress(
  Sender: TObject; var UTF8Key: TUTF8Char);

begin
  //KeyPreview := TRUE;
  with DBG_movimentos_cc_nb do
  case UTF8Key of
//    #75 : SelectedIndex := SelectedIndex - 1;                    //WriteLn('Left');    Experiência desnecessário
//    #77 : SelectedIndex := SelectedIndex + 1;                    //WriteLn('Right');   Experiência desnecessário
//     #9 : SelectedIndex := SelectedIndex + 1;                    //WriteLn('Tab');     Experiência desnecessário
    #13 : frm_dm_movimentos.SQLQ_movimentos_NB.Next;               //Writeln('Return');
  end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.FormShow(Sender: TObject);
begin
  que_cartao := 'João';
  frm_dm_movimentos.SQLQ_cartoes_nb.Active := FALSE;
  frm_dm_movimentos.SQLQ_cartoes_nb.SQL.Text := 'SELECT * FROM sch_conta.movimentos_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39) + ' order by estado ASC';    // estado=data
  frm_dm_movimentos.SQLQ_cartoes_nb.Active := TRUE; //showmessage('passou    ' + frm_dm_movimentos.SQLQ_movimentos_nb.SQL.Text);
  frm_edita_cc_nb_movimentos.Caption := frm_edita_cc_nb_movimentos.Caption + '  '  + que_cartao;
  frm_edita_cc_nb_movimentos.l_Titulo.Caption := frm_edita_cc_nb_movimentos.l_Titulo.Caption + '  ' + que_cartao;
  E_que_cartao.Text := 'Cartão:  ' + que_cartao;

  frm_dm_movimentos.SQLQ_total_cartoes_nb.Active := FALSE;
  frm_dm_movimentos.SQLQ_total_cartoes_nb.SQL.Text := 'SELECT total_montante as Total_Montante FROM sch_conta.v_totais_cc_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39);
  frm_dm_movimentos.SQLQ_total_cartoes_nb.Active := TRUE;

{ pode ainda ter uso para a moeda estrangeira
//    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := FALSE;          // alternativa
  frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Close;
  frm_dm_movimentos.SQLQ_totais_debito_credito_NB.SQL.Text := 'SELECT debito, credito, conta FROM sch_conta.v_totais_deve_haver_nb WHERE cartao = ' + chr(39) + que_cartao + chr(39);
//    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Active := TRUE;      // alternativa
  frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Open;
//    frm_dm_movimentos.SQLQ_totais_debito_credito_NB.Refresh;             // alternativa
}

  E_que_cartao.Text := 'Cartão activo:  ' + que_cartao + '.  Clique para aceder ao outro cartão!';
//  DBN_movimentos_cc_nb.DataSource := frm_DM_movimentos.DS_Cartoes_NB;
//  DBG_movimentos_cc_nb.DataSource := frm_DM_movimentos.DS_Cartoes_NB;

//  exit;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.DBG_movimentos_cc_nbColExit(Sender: TObject);
begin
  if DBG_movimentos_cc_nb.SelectedField.FieldName = DBLCB_tipo_movimento.DataField then
    begin
      DBLCB_tipo_movimento.Visible := FALSE;
      DBLCB_analisado.Visible := FALSE;
    end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.DBG_movimentos_cc_nbDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.DBG_movimentos_cc_nbDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  if (gdFocused in State) then
  begin
    if (Column.Field.FieldName = DBLCB_tipo_movimento.DataField) then
    with DBLCB_tipo_movimento do
    begin
//      Left := Rect.Left + DBG_movimentos_cc_nb.Left + 2;
      Left := Rect.Left + DBG_movimentos_cc_nb.Left - 180;         // à esquerda da coluna
//      Top := Rect.Top + DBG_movimentos_cc_nb.Top + 2;
      Top := Rect.Top + DBG_movimentos_cc_nb.Top - 15;             // acima da linha
      Width := Rect.Right - Rect.Left + 100;     // +80 para extravazar a célula
//      Width := Rect.Right - Rect.Left;
      Height := Rect.Bottom - Rect.Top;
      DBLCB_tipo_movimento.Visible := True;
      DBLCB_analisado.Visible := FALSE;       // para garantir que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
      if frm_dm_movimentos.SQLQ_tipos_movimento.Active = FALSE then frm_dm_movimentos.SQLQ_tipos_movimento.Active := TRUE;
    end
    else if (Column.Field.FieldName = DBLCB_analisado.DataField) then
    with DBLCB_analisado do
    begin
//      Left := Rect.Left + DBG_movimentos_cc_nb.Left + 2;
      Left := Rect.Left + DBG_movimentos_cc_nb.Left - 80;            // à esquerda da coluna
//      Top := Rect.Top + DBG_movimentos_cc_nb.Top + 2;
      Top := Rect.Top + DBG_movimentos_cc_nb.Top - 15;               // acima da linha
      Width := Rect.Right - Rect.Left + 40;     // +80 para extravazar a célula
//      Width := Rect.Right - Rect.Left;
      Height := Rect.Bottom - Rect.Top;
      DBLCB_analisado.Visible := True;
      DBLCB_tipo_movimento.Visible := FALSE;      // para garantir que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
      if frm_dm_movimentos.SQLQ_analisado.Active = FALSE then frm_dm_movimentos.SQLQ_analisado.Active := TRUE;
    end
    else
    begin
      DBLCB_tipo_movimento.Visible := FALSE;     // conjugado com a instrução acima, para cada DBLCB, garante que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
      DBLCB_analisado.Visible := FALSE;  // conjugado com a instrução acima, para cada DBLCB, garante  que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
    end;
  end
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.B_rollbackClick(Sender: TObject);
begin
  frm_dm_movimentos.SQLT_movimentos.Rollback;
  frm_dm_movimentos.SQLQ_movimentos_NB.Active := FALSE;
  frm_dm_movimentos.SQLQ_movimentos_NB.Active := TRUE;


  if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.B_sai_pesquisa_livreClick(Sender: TObject);
begin
    GB_pesquisa_livre.Visible := FALSE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.B_pesquisa_livreClick(Sender: TObject);
begin
  GB_pesquisa_livre.Top := 140;
  GB_pesquisa_livre.Left := 600;
  GB_pesquisa_livre.Width := 600;
  GB_pesquisa_livre.Height := 330;
  GB_pesquisa_livre.Color := $00B8FEFB;
  GB_pesquisa_livre.Visible := TRUE;

  M_pesquisa_livre.Left := 2;
  M_pesquisa_livre.Top := 2;
  M_pesquisa_livre.Width := 593;
  M_pesquisa_livre.Height := 250;
  M_pesquisa_livre.Enabled := TRUE;
  M_pesquisa_livre.Lines.Add('primeira linha');
  M_pesquisa_livre.CanFocus;

  B_executa_pesquisa_livre.Left := 190;
  B_executa_pesquisa_livre.Top := M_pesquisa_livre.Height + 15;

  B_pesquisa_livre_rollback.Left := B_executa_pesquisa_livre.Left + 70;
  B_pesquisa_livre_rollback.Top := M_pesquisa_livre.Height + 15;

  B_sai_pesquisa_livre.Left := B_pesquisa_livre_rollback.Left + 100;
  B_sai_pesquisa_livre.Top := M_pesquisa_livre.Height + 15;

  B_executa_pesquisa_livre.Visible := TRUE;
  B_sai_pesquisa_livre.Visible := TRUE;
  B_pesquisa_livre_rollback.Visible := TRUE;
  M_pesquisa_livre.Visible := TRUE;

  M_pesquisa_livre.Clear;
  M_pesquisa_livre.Lines.Add('select   *');
  M_pesquisa_livre.Lines.Add('from   sch_conta.movimentos_cc_nb');
  M_pesquisa_livre.Lines.Add('where  upper(cartao) = ' + chr(39) + AnsiUpperCase(que_cartao) + chr(39) );
  M_pesquisa_livre.Lines.Add('and    ');
  M_pesquisa_livre.Lines.Add('order   by  estado ASC');    //estado=data


//  B_executa_pesquisa_livre.Visible := FALSE;
//  M_pesquisa_livre.Visible := FALSE;
(*

//  clausula_where := InputBox('Definição das condições de pesquisa', 'Complete s.f.f. a cláuslua where (e.g: and data_mov > 17-02-2018):', ('where' + sLineBreak + 'clausula'));

//  InputQuery('Definição das condições de pesquisa', 'Complete s.f.f. a cláuslua where (e.g: and data_mov > 17-02-2018):', clausula_where);
//  if clausula_where <> '' then
  begin
    clausula_where := 'where 1 = 1  ' + ' AND ' + clausula_where;
    SQL_Text := 'select * from sch_conta.movimentos_cc_nb ' + clausula_where + ' order by pk_movimentos_cc_nb ASC';   // completa a formação da instrução SQL a sujeitar à BD

    frm_dm_movimentos.SQLQ_movimentos1.SQL.Text := SQL_Text;
    frm_dm_movimentos.SQLQ_movimentos1.Active := FALSE;
    showmessage(frm_dm_movimentos.SQLQ_movimentos1.SQL.Text);
    frm_dm_movimentos.SQLQ_movimentos1.Active := TRUE;

    frm_dm_movimentos.SQLQ_total_movimentos.Refresh;    // refresca a contagem de movimentos na BD
//    Hide;
//  end;
*)
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.B_executa_pesquisa_livreClick(Sender: TObject);
begin
  try
    SQL_Text := M_pesquisa_livre.Text;
    frm_dm_movimentos.SQLQ_cartoes_nb.SQL.Text := SQL_Text;
    frm_dm_movimentos.SQLQ_cartoes_nb.Active := FALSE;
    showmessage(frm_dm_movimentos.SQLQ_cartoes_nb.SQL.Text);
    frm_dm_movimentos.SQLQ_cartoes_nb.Active := TRUE;

    frm_dm_movimentos.SQLQ_total_movimentos_NB.Refresh;    // refresca a contagem de movimentos na BD
    GB_pesquisa_livre.Visible := FALSE;

  except
  on E: Exception do
  begin
    MessageDlg('Erro: ', 'A instrução SQL provavelmente não está correcta: ' + chr(13) +
                         'Clique s.f.f. sobre o botão Rollback nesta janela, para ' + chr(13) +
                         'seguidamente corrijir a instrução SQL e tentar de novo.' + chr(13) +
                         '----------------------------------------------------------' + chr(13) +
                         '                                                          ' + chr(13) +
                          E.Message, mterror, [mbOK], 0);
  end;
  end;
end;

procedure Tfrm_edita_cc_nb_movimentos.B_pesquisa_livre_RollbackClick(Sender: TObject);
begin
  SQL_Text := 'select * from sch_conta.movimentos_cc_nb order by data_oper ASC';
  frm_dm_movimentos.SQLQ_cartoes_nb.Clear;
  frm_dm_movimentos.SQLQ_cartoes_nb.SQL.Text := SQL_Text;

  frm_dm_movimentos.SQLT_movimentos.Rollback;
  frm_dm_movimentos.SQLQ_cartoes_nb.Active := FALSE;
  frm_dm_movimentos.SQLQ_cartoes_nb.Active := TRUE;

  if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
    frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.FormCreate(Sender: TObject);
const
  SALDO_SECTION = 'Saldo';
var
  INI: TINIFile;

begin
  exit;
  INI := TINIFile.Create('ficheiro_em_tratamento.ini');
  E_Saldo.Text := INI.ReadString(SALDO_SECTION,'Saldo','');
  INI.Free;

  KeyPreview := TRUE;
  Top := 210;
  Left := 40;
  Width := 1800;
  Height := 700;

  DBG_movimentos_cc_nb.Top := 50;
  DBG_movimentos_cc_nb.Left := 15;
  DBG_movimentos_cc_nb.Width := 1780;
  DBG_movimentos_cc_nb.Height := 560;

  DBE_total_movimentos.Left := 1457;
  L_num_movimentos.Left := 1300;

  DBN_movimentos_cc_nb.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 35;
  DBN_movimentos_cc_nb.Left := DBG_movimentos_cc_nb.Left;

  SB_PrepQuery.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 35;
  SB_PrepQuery.Left := DBN_movimentos_cc_nb.Left + DBN_movimentos_cc_nb.Width + 30;

  B_pesquisa_livre.Top := SB_PrepQuery.Top;
  B_pesquisa_livre.Left := SB_PrepQuery.Left + SB_PrepQuery.Width + 100;

  SB_Exit.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 35;
  SB_Exit.Left := SB_PrepQuery.Left + SB_PrepQuery.Width + 350;

  B_RollBack.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 35;
  B_RollBack.Left := SB_Exit.Left + SB_Exit.Width + 400;

  DBE_debito.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 5;
  DBE_debito.Left := 700;
  DBE_debito.Width := 60;

  DBE_credito.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 5;
  DBE_credito.Left := 770;
  DBE_credito.Width := 60;

  E_Saldo.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 5;
  L_Saldo.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 7;

  SB_Inverte_a_Ordem.Top := DBG_movimentos_cc_nb.Top + DBG_movimentos_cc_nb.Height + 5;
  SB_Inverte_a_Ordem.Left := DBG_movimentos_cc_nb.Left;

  DBLCB_tipo_movimento.DataSource := frm_dm_movimentos.DS_movimentos_NB;
  DBLCB_tipo_movimento.ListSource := frm_dm_movimentos.DS_Tipos_movimento;
//

// ligação à BD
  DBG_movimentos_cc_nb.DataSource := frm_dm_movimentos.DS_movimentos_NB;
  DBN_movimentos_cc_nb.DataSource := frm_dm_movimentos.DS_movimentos_NB;

  TNumericField(frm_dm_movimentos.SQLQ_movimentos_NB.FieldByName('data_oper')).DisplayFormat := 'dd/mm/yyyy';  // o formato poderia, também, ser 'dd-mm-yy hh:mm:ss'
  TNumericField(frm_dm_movimentos.SQLQ_movimentos_NB.FieldByName('data_oper')).EditMask := '!99/99/9999';

  TNumericField(frm_dm_movimentos.SQLQ_movimentos_NB.FieldByName('data_val')).DisplayFormat := 'dd/mm/yyyy';  // o formato poderia, também, ser 'dd-mm-yy hh:mm:ss'
  TNumericField(frm_dm_movimentos.SQLQ_movimentos_NB.FieldByName('data_val')).EditMask := '!99/99/9999';

// a máscara (editmask) foi definida no query
//funciona  TStringField(frm_dm_movimentos.SQLQ_movimentos1.FieldByName('descricao')).EditMask := '>aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa;0;_';

  frm_dm_movimentos.SQLQ_total_movimentos_NB.Refresh;    //refresca a contagem do total de movimentos na BD

  with frm_dm_movimentos do
  begin
    if frm_dm_movimentos.SQLQ_totais_debito_credito_nb.Active = FALSE then
       frm_dm_movimentos.SQLQ_totais_debito_credito_nb.Active := TRUE;

    DBE_debito.DataSource := frm_dm_movimentos.DS_totais_debito_credito_nb;
    DBE_debito.DataField := 'debito';

    DBE_credito.DataSource := frm_dm_movimentos.DS_totais_debito_credito_nb;
    DBE_credito.DataField := 'credito';

    if frm_dm_movimentos.SQLQ_movimentos_NB.Active = FALSE then
       frm_dm_movimentos.SQLQ_movimentos_NB.Active := TRUE;

    if frm_dm_movimentos.SQLQ_total_movimentos_NB.Active = FALSE then
       frm_dm_movimentos.SQLQ_total_movimentos_NB.Active := TRUE;
  end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.SB_ExitClick(Sender: TObject);
begin
  Close;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.SB_Inverte_a_OrdemClick(Sender: TObject);
begin
  if Ordem_Movimentos = 'ASC' then Ordem_Movimentos := 'DESC'
  else
  if Ordem_Movimentos = 'DESC' then Ordem_Movimentos := 'ASC';

  frm_dm_movimentos.SQLQ_cartoes_nb.Active := FALSE;
  frm_dm_movimentos.SQLQ_cartoes_nb.SQL.Text := 'select * from sch_conta.movimentos_cc_nb order by estado ' + Ordem_Movimentos;
  frm_dm_movimentos.SQLQ_cartoes_nb.Active := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cc_nb_movimentos.SB_PrepQueryClick(Sender: TObject);
begin
  frm_prep_query_cc_nb_movimentos.show;
  with frm_prep_query_cc_nb_movimentos do
  begin
    E_cartao_activo.visible := TRUE;
    E_PK_movimento.visible := TRUE;
    E_estado.visible := TRUE;
    E_nome_comercio.visible := TRUE;
    E_desc_factura.visible := TRUE;
    E_taxas_comissoes.visible := TRUE;
    E_montante.visible := TRUE;
    E_moeda_debito.visible := TRUE;
    E_analisado.visible := TRUE;
    E_cod_tipo_movimento.Visible := TRUE;
    E_montante_moeda_orig.visible := TRUE;
    E_moeda_origem.Visible := TRUE;
    E_notas.Visible := TRUE;
//
    L_cartao_activo.visible := TRUE;
    L_PK_movimento.visible := TRUE;
    L_estado.visible := TRUE;
    L_nome_comercio.visible := TRUE;
    L_desc_factura.visible := TRUE;
    L_taxas_comissoes.visible := TRUE;
    L_montante.visible := TRUE;
    L_moeda_debito.visible := TRUE;
    L_cod_tipo_movimento.Visible := TRUE;
    L_analisado.visible := TRUE;
    L_montante_moeda_orig.visible := TRUE;
    L_moeda_origem.Visible := TRUE;
    L_notas.Visible := TRUE;
  end;
end;

end.

