unit u_edita_cgd_movimentos;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, SQLDB, Forms, Controls,
  Dialogs, DBGrids, DBCtrls, Buttons, StdCtrls, Grids, ExtCtrls, MaskEdit,
  u_prep_query_cgd_movimentos, LCLType, IniFiles, u_dm_movimentos;           //SQLite3Conn, ExtCtrls, strutils, Graphics,

type

  { Tfrm__edita_cgd_movimentos }

  Tfrm_edita_cgd_movimentos = class(TForm)
    B_pesquisa_livre_Rollback: TButton;
    B_sai_pesquisa_livre: TButton;
    B_executa_pesquisa_livre: TButton;
    B_pesquisa_livre: TButton;
    B_rollback: TButton;
    DBE_total_movimentos: TDBEdit;
    DBE_credito: TDBEdit;
    DBE_debito: TDBEdit;
    DBLCB_tipo_movimento: TDBLookupComboBox;
    DBG_movimentos: TDBGrid;
    DBLCB_analisado: TDBLookupComboBox;
    DBN_movimentos: TDBNavigator;
    E_Saldo: TEdit;
    GB_pesquisa_livre: TGroupBox;
    IL_movimentos: TImageList;
    L_Saldo: TLabel;
    L_num_movimentos: TLabel;
    L_titulo: TLabel;
    M_pesquisa_livre: TMemo;
    SB_Exit: TSpeedButton;
    SB_PrepQuery: TSpeedButton;
    SB_Inverte_a_Ordem: TSpeedButton;
    procedure B_pesquisa_livre_RollbackClick(Sender: TObject);
    procedure B_executa_pesquisa_livreClick(Sender: TObject);
    procedure B_pesquisa_livreClick(Sender: TObject);
    procedure B_rollbackClick(Sender: TObject);
    procedure B_sai_pesquisa_livreClick(Sender: TObject);
    procedure DBG_movimentosColExit(Sender: TObject);
    procedure DBG_movimentosDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DBG_movimentosDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure DBG_movimentosKeyPress(Sender: TObject; var Key: char);
    procedure DBG_movimentosTitleClick(Column: TColumn);
    procedure DBLCB_tipo_movimentoUTF8KeyPress(Sender: TObject;
      var UTF8Key: TUTF8Char);
    procedure DBN_movimentosClick(Sender: TObject; Button: TDBNavButtonType);
    procedure FormCreate(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SB_ExitClick(Sender: TObject);
    procedure SB_Inverte_a_OrdemClick(Sender: TObject);
    procedure SB_PrepQueryClick(Sender: TObject);
  private

  public

  end;

var
  frm_edita_cgd_movimentos: Tfrm_edita_cgd_movimentos;
  clausula_where,
  SQL_text: string;

  op_PK_movimento,
  op_data_mov,
  op_data_valor,
  op_descricao,
  op_debito,
  op_credito,
  op_saldo_contabilistico,
  op_saldo_disponivel,
  op_categoria,
  op_cod_tipo_movimento,
  op_analisado: string;

  ord_pk_movimentos_cgd: string = 'ASC';
  ord_data_mov: string = 'ASC';
  ord_data_valor: string = 'ASC';
  ord_descricao: string = 'ASC';
  ord_debito: string = 'ASC';
  ord_credito: string = 'ASC';
  ord_saldo_contabilistico: string = 'ASC';
  ord_saldo_disponivel: string = 'ASC';
  ord_categoria: string = 'ASC';
  ord_analisado: string = 'ASC';
  ord_cod_tipo_movimento: string = 'ASC';
  ord_notas: string = 'ASC';

  Ordem_Movimentos: string = 'ASC';
implementation
// uses u_dm_movimentos;

{$R *.frm}

{ Tfrm_edita_cgd_movimentos }

procedure Tfrm_edita_cgd_movimentos.DBN_movimentosClick(Sender: TObject; Button: TDBNavButtonType);
var
  BtnName: string;
begin
  case Button of
    nbFirst  : BtnName := 'nbFirst';
    nbPrior  : BtnName := 'nbPrior';
//    nbNext   : BtnName := 'nbNext';
    nbNext   : begin
               try
                 case frm_dm_movimentos.SQLQ_movimentos_CGD.UpdateStatus of    //deteta alterações aos dados em SQLQ_movimentos
//                    usUnmodified : ShowMessage('Unmodified');
                      usModified   : begin                            // ensaios vários. inconsequentes
//                                       showmessage('modifi9ado');
                                      end;
                      usInserted   : ShowMessage('Inserted');
                      usDeleted    : ShowMessage('Deleted');
                 end;

               except
               on E: Exception do
               begin
                 MessageDlg('Error', 'Problema acedendo ao registo seguinte. Mensagem técnica do erro: ' + E.Message, mterror, [mbOK], 0);
               end;
               end;

               end;

    nbLast   : BtnName := 'nbLast';
    nbInsert : BtnName := 'nbInsert';
    nbDelete : BtnName := 'nbDelete';
    nbEdit   : BtnName := 'nbEdit';
    nbPost   : begin
                 try
                 frm_dm_movimentos.SQLQ_Movimentos_CGD.Open;
                 frm_dm_movimentos.SQLQ_Movimentos_CGD.Edit;
                 frm_dm_movimentos.SQLQ_Movimentos_CGD.UpdateMode := upWhereAll;
                 frm_dm_movimentos.SQLQ_Movimentos_CGD.ApplyUpdates;
//                 SQLT_Movimentos.Commit;
                 frm_dm_movimentos.SQLQ_Movimentos_CGD.Open;

//                 SQLQ_Movimentos.Refresh;

                 except
                   on E: Exception do
                   begin
                     MessageDlg('Error', 'Problema com Post/Update. Mensagem técnica do erro: ' + E.Message, mterror, [mbOK], 0);
                   end;
                  end;
               end;
    nbCancel : BtnName := 'nbCancel';
    nbRefresh: BtnName := 'nbRefresh';
  end;

  if frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active = FALSE then
     frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active := TRUE;   // refresca a contagem do total de movimentos na BD

  if frm_dm_movimentos.SQLQ_totais_debito_credito_cgd.Active = FALSE then
     frm_dm_movimentos.SQLQ_totais_debito_credito_cgd.Active := TRUE;   // refresca a determinação dos totais das colunas  debito e credito na BD
end;

procedure Tfrm_edita_cgd_movimentos.DBG_movimentosKeyPress(Sender: TObject; var Key: char);
begin
  if (key = Chr(9)) then Exit;
  if (DBG_movimentos.SelectedField.FieldName = DBLCB_tipo_movimento.DataField) then
  begin
    DBLCB_tipo_movimento.SetFocus;
//    SendMessage(DBLCB_tipo_movimento.Handle, WM_Char, word(Key), 0);    // aparentemente desnecessário
  end
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.DBG_movimentosTitleClick(Column: TColumn);
var
  i: integer;

begin
  with frm_dm_movimentos.SQLQ_movimentos_CGD do
  begin
//
//    InputQuery('Complete s.f.f. a cláusula where', 'Complete s.f.f. a cláuslua where:', index);           // escreve o nome de cada coluna do grid
//    if index <> '' then
//       ShowMessage(DBG_movimentos.Columns[StrToInt(index)].FieldName);

//    InputQuery('Definição complementar das condições de pesquisa', 'Complete s.f.f. a cláuslua where:', c_where);
//    if c_where <> '' then
//    begin
//      c_where := 'where 1 = 1  ' + ' AND ' + c_where;
//    end;
//
    for i := 0 to DBG_movimentos.Columns.Count -1 do      // limpa os UP e DOWN dos títulos de todas as colunas antes de cada ordenação por qualquer coluna
    begin
      DBG_movimentos.Columns.Items[i].Title.ImageIndex := 2;
    end;;

    Close;
    SQL.Clear;
//                                  PK_MOVIMENTOS_CGD
    if column.FieldName = 'pk_movimentos_cgd' then
    begin
      if ord_pk_movimentos_cgd = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by pk_movimentos_cgd ' + ' ASC');
        ord_pk_movimentos_cgd := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by pk_movimentos_cgd ' + 'DESC');
        ord_pk_movimentos_cgd := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
    //                                  DATA_MOV
    else if column.FieldName = 'data_mov' then
    begin
      if ord_data_mov = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by data_mov ' + 'ASC');
        ord_data_mov := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by data_mov ' + 'DESC');
        ord_data_mov := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  DATA_VALOR
    else if column.FieldName = 'data_valor' then
    begin
      if ord_data_valor = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by data_valor ' + 'ASC');
        ord_data_valor := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by data_valor ' + 'DESC');
        ord_data_valor := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  DESCRICAO
    else if column.FieldName = 'descricao' then
    begin
      if ord_descricao = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by descricao ' + 'ASC');
        ord_descricao := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by descricao ' + 'DESC');
        ord_descricao := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  DEBITO
    else if column.FieldName = 'debito' then
    begin
      if ord_debito = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(debito,0)::NUMERIC ' + 'ASC');
        ord_debito := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(debito,0)::NUMERIC ' + 'DESC');
        ord_debito := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  CREDITO
    else if column.FieldName = 'credito' then
    begin
      if ord_credito = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(credito,0)::NUMERIC ' + 'ASC');
        ord_credito := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(credito,0)::NUMERIC ' + 'DESC');
        ord_credito := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  SALDO_CONTABILISTICO
    else if column.FieldName = 'saldo_contabilistico' then
    begin
      if ord_saldo_contabilistico = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(saldo_contabilistico,0)::NUMERIC ' + 'ASC');
        ord_saldo_contabilistico := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(saldo_contabilistico,0)::NUMERIC ' + 'DESC');
        ord_saldo_contabilistico := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  SALDO_DISPONIVEL
    else if column.FieldName = 'saldo_disponivel' then
    begin
      if ord_saldo_disponivel = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(saldo_disponivel,0)::NUMERIC ' + 'ASC');
        ord_saldo_disponivel := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(saldo_disponivel,0)::NUMERIC ' + 'DESC');
        ord_saldo_disponivel := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  CATEGORIA
    else if column.FieldName = 'categoria' then
    begin
      if ord_categoria = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by categoria ' + 'ASC');
        ord_categoria := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by categoria ' + 'DESC');
        ord_categoria := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  COD_TIPO_MOVIMENTO
    else if column.FieldName = 'cod_tipo_movimento' then
    begin
      if ord_cod_tipo_movimento = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(cod_tipo_movimento,0)::INTEGER ' + 'ASC');
        ord_cod_tipo_movimento := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by coalesce(cod_tipo_movimento,0)::INTEGER ' + 'DESC');
        ord_cod_tipo_movimento := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  ANALISADO
    else if column.FieldName = 'analisado' then
    begin
      if ord_analisado = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by analisado ' + 'ASC');
        ord_analisado := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by analisado ' + 'DESC');
        ord_analisado := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
//                                  NOTAS
    else if column.FieldName = 'notas' then
    begin
      if ord_notas = 'DESC' then
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by notas ' + 'ASC');
        ord_notas := 'ASC';
        column.Title.ImageIndex := 0;
      end
      else
      begin
        SQL.Add('select * from sch_conta.movimentos_cgd order by notas ' + 'DESC');
        ord_notas := 'DESC';
        column.Title.ImageIndex := 1;
      end
    end
    else
    SQL.Add('select * from sch_conta.movimentos_cgd order by pk_movimentos_cgd ' + 'ASC');
//
    Open;
  end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.DBLCB_tipo_movimentoUTF8KeyPress(
  Sender: TObject; var UTF8Key: TUTF8Char);

begin
  //KeyPreview := TRUE;
  with DBG_movimentos do
  case UTF8Key of
//    #75 : SelectedIndex := SelectedIndex - 1;                    //WriteLn('Left');    Experiência desnecessário
//    #77 : SelectedIndex := SelectedIndex + 1;                    //WriteLn('Right');   Experiência desnecessário
//     #9 : SelectedIndex := SelectedIndex + 1;                    //WriteLn('Tab');     Experiência desnecessário
    #13 : frm_dm_movimentos.SQLQ_movimentos_CGD.Next;               //Writeln('Return');
  end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.DBG_movimentosColExit(Sender: TObject);
begin
  if DBG_movimentos.SelectedField.FieldName = DBLCB_tipo_movimento.DataField then
    begin
      DBLCB_tipo_movimento.Visible := FALSE;
      DBLCB_analisado.Visible := FALSE;
    end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.DBG_movimentosDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.DBG_movimentosDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
begin
  if (gdFocused in State) then
  begin
    if (Column.Field.FieldName = DBLCB_tipo_movimento.DataField) then
    with DBLCB_tipo_movimento do
    begin
//      Left := Rect.Left + DBG_movimentos.Left + 2;
      Left := Rect.Left + DBG_movimentos.Left - 180;         // à esquerda da coluna
//      Top := Rect.Top + DBG_movimentos.Top + 2;
      Top := Rect.Top + DBG_movimentos.Top - 15;             // acima da linha
      Width := Rect.Right - Rect.Left + 100;     // +80 para extravazar a célula
//      Width := Rect.Right - Rect.Left;
      Height := Rect.Bottom - Rect.Top;
      DBLCB_tipo_movimento.Visible := True;
      DBLCB_analisado.Visible := FALSE;       // para garantir que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
      if frm_dm_movimentos.SQLQ_tipos_movimento.Active = FALSE then frm_dm_movimentos.SQLQ_tipos_movimento.Active := TRUE;
    end
    else if (Column.Field.FieldName = DBLCB_analisado.DataField) then
    with DBLCB_analisado do
    begin
//      Left := Rect.Left + DBG_movimentos.Left + 2;
      Left := Rect.Left + DBG_movimentos.Left - 80;            // à esquerda da coluna
//      Top := Rect.Top + DBG_movimentos.Top + 2;
      Top := Rect.Top + DBG_movimentos.Top - 15;               // acima da linha
      Width := Rect.Right - Rect.Left + 40;     // +80 para extravazar a célula
//      Width := Rect.Right - Rect.Left;
      Height := Rect.Bottom - Rect.Top;
      DBLCB_analisado.Visible := True;
      DBLCB_tipo_movimento.Visible := FALSE;      // para garantir que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
      if frm_dm_movimentos.SQLQ_analisado.Active = FALSE then frm_dm_movimentos.SQLQ_analisado.Active := TRUE;
    end
    else
    begin
      DBLCB_tipo_movimento.Visible := FALSE;     // conjugado com a instrução acima, para cada DBLCB, garante que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
      DBLCB_analisado.Visible := FALSE;  // conjugado com a instrução acima, para cada DBLCB, garante  que em colunas contíguas com DBLCBox a DBLCBox anterior desparece quando muda para a coluna seguinte ou para a coiluna anterior
    end;
  end
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.B_rollbackClick(Sender: TObject);
begin
  frm_dm_movimentos.SQLT_movimentos.Rollback;
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := FALSE;
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := TRUE;


  if frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active = FALSE then
    frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.B_sai_pesquisa_livreClick(Sender: TObject);
begin
    GB_pesquisa_livre.Visible := FALSE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.B_pesquisa_livreClick(Sender: TObject);
begin
  GB_pesquisa_livre.Top := 140;
  GB_pesquisa_livre.Left := 600;
  GB_pesquisa_livre.Width := 600;
  GB_pesquisa_livre.Height := 330;
  GB_pesquisa_livre.Color := $00B8FEFB;
  GB_pesquisa_livre.Visible := TRUE;

  M_pesquisa_livre.Left := 2;
  M_pesquisa_livre.Top := 2;
  M_pesquisa_livre.Width := 593;
  M_pesquisa_livre.Height := 250;
  M_pesquisa_livre.Enabled := TRUE;
  M_pesquisa_livre.Lines.Add('primeira linha');
  M_pesquisa_livre.CanFocus;

  B_executa_pesquisa_livre.Left := 190;
  B_executa_pesquisa_livre.Top := M_pesquisa_livre.Height + 15;

  B_pesquisa_livre_rollback.Left := B_executa_pesquisa_livre.Left + 70;
  B_pesquisa_livre_rollback.Top := M_pesquisa_livre.Height + 15;

  B_sai_pesquisa_livre.Left := B_pesquisa_livre_rollback.Left + 100;
  B_sai_pesquisa_livre.Top := M_pesquisa_livre.Height + 15;

  B_executa_pesquisa_livre.Visible := TRUE;
  B_sai_pesquisa_livre.Visible := TRUE;
  B_pesquisa_livre_rollback.Visible := TRUE;
  M_pesquisa_livre.Visible := TRUE;

  M_pesquisa_livre.Clear;
  M_pesquisa_livre.Lines.Add('select   *');
  M_pesquisa_livre.Lines.Add('from   sch_conta.movimentos_cgd');
  M_pesquisa_livre.Lines.Add('where      ');
  M_pesquisa_livre.Lines.Add('order   by  pk_movimentos_cgd');

//  B_executa_pesquisa_livre.Visible := FALSE;
//  M_pesquisa_livre.Visible := FALSE;
(*

//  clausula_where := InputBox('Definição das condições de pesquisa', 'Complete s.f.f. a cláuslua where (e.g: and data_mov > 17-02-2018):', ('where' + sLineBreak + 'clausula'));

//  InputQuery('Definição das condições de pesquisa', 'Complete s.f.f. a cláuslua where (e.g: and data_mov > 17-02-2018):', clausula_where);
//  if clausula_where <> '' then
  begin
    clausula_where := 'where 1 = 1  ' + ' AND ' + clausula_where;
    SQL_Text := 'select * from sch_conta.movimentos_cgd ' + clausula_where + ' order by pk_movimentos_cgd ASC';   // completa a formação da instrução SQL a sujeitar à BD

    frm_dm_movimentos.SQLQ_movimentos1.SQL.Text := SQL_Text;
    frm_dm_movimentos.SQLQ_movimentos1.Active := FALSE;
    showmessage(frm_dm_movimentos.SQLQ_movimentos1.SQL.Text);
    frm_dm_movimentos.SQLQ_movimentos1.Active := TRUE;

    frm_dm_movimentos.SQLQ_total_movimentos.Refresh;    // refresca a contagem de movimentos na BD
//    Hide;
//  end;
*)

end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.B_executa_pesquisa_livreClick(Sender: TObject);
begin
  try
    SQL_Text := M_pesquisa_livre.Text;
    frm_dm_movimentos.SQLQ_movimentos_CGD.SQL.Text := SQL_Text;
    frm_dm_movimentos.SQLQ_movimentos_CGD.Active := FALSE;
    showmessage(frm_dm_movimentos.SQLQ_movimentos_CGD.SQL.Text);
    frm_dm_movimentos.SQLQ_movimentos_CGD.Active := TRUE;

    frm_dm_movimentos.SQLQ_total_movimentos_CGD.Refresh;    // refresca a contagem de movimentos na BD
    GB_pesquisa_livre.Visible := FALSE;

  except
  on E: Exception do
  begin
    MessageDlg('Erro: ', 'A instrução SQL provavelmente não está correcta: ' + chr(13) +
                         'Clique s.f.f. sobre o botão Rollback nesta janela, para ' + chr(13) +
                         'seguidamente corrijir a instrução SQL e tentar de novo.' + chr(13) +
                         '----------------------------------------------------------' + chr(13) +
                         '                                                          ' + chr(13) +
                          E.Message, mterror, [mbOK], 0);
  end;
  end;
end;

procedure Tfrm_edita_cgd_movimentos.B_pesquisa_livre_RollbackClick(Sender: TObject);
begin
  SQL_Text := 'select * from sch_conta.movimentos_cgd order by pk_movimentos_cgd';
  frm_dm_movimentos.SQLQ_movimentos_CGD.Clear;
  frm_dm_movimentos.SQLQ_movimentos_CGD.SQL.Text := SQL_Text;

  frm_dm_movimentos.SQLT_movimentos.Rollback;
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := FALSE;
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := TRUE;

  if frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active = FALSE then
    frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.FormCreate(Sender: TObject);
const
  SALDO_SECTION = 'Saldo';
var
  INI: TINIFile;

begin
  INI := TINIFile.Create('ficheiro_em_tratamento.ini');
  E_Saldo.Text := INI.ReadString(SALDO_SECTION,'Saldo','');
  INI.Free;


  KeyPreview := TRUE;
  Top := 210;
  Left := 210;
  Width := 1550;
  Height := 700;

  DBG_movimentos.Top := 50;
  DBG_movimentos.Left := 15;
  DBG_movimentos.Height := 560;
  DBG_movimentos.Width := 1523;

  DBE_total_movimentos.Left := 1457;
  L_num_movimentos.Left := 1300;

  DBN_movimentos.Top := DBG_movimentos.Top + DBG_movimentos.Height + 35;
  DBN_movimentos.Left := DBG_movimentos.Left;

  SB_PrepQuery.Top := DBG_movimentos.Top + DBG_movimentos.Height + 35;
  SB_PrepQuery.Left := DBN_movimentos.Left + DBN_movimentos.Width + 30;

  B_pesquisa_livre.Top := SB_PrepQuery.Top;
  B_pesquisa_livre.Left := SB_PrepQuery.Left + SB_PrepQuery.Width + 100;

  SB_Exit.Top := DBG_movimentos.Top + DBG_movimentos.Height + 35;
  SB_Exit.Left := SB_PrepQuery.Left + SB_PrepQuery.Width + 350;

  B_RollBack.Top := DBG_movimentos.Top + DBG_movimentos.Height + 35;
  B_RollBack.Left := SB_Exit.Left + SB_Exit.Width + 400;

  DBE_debito.Top := DBG_movimentos.Top + DBG_movimentos.Height + 5;
  DBE_debito.Left := 502;
  DBE_debito.Width := 85;

  DBE_credito.Top := DBG_movimentos.Top + DBG_movimentos.Height + 5;
  DBE_credito.Left := 594;
  DBE_credito.Width := 85;

  E_Saldo.Top := DBG_movimentos.Top + DBG_movimentos.Height + 5;
  L_Saldo.Top := DBG_movimentos.Top + DBG_movimentos.Height + 7;

  DBLCB_tipo_movimento.DataSource := frm_dm_movimentos.DS_movimentos_CGD;
  DBLCB_tipo_movimento.ListSource := frm_dm_movimentos.DS_Tipos_movimento;
//
// ligação à BD
  DBG_movimentos.DataSource := frm_dm_movimentos.DS_movimentos_CGD;
  DBN_movimentos.DataSource := frm_dm_movimentos.DS_movimentos_CGD;

  TNumericField(frm_dm_movimentos.SQLQ_movimentos_CGD.FieldByName('data_mov')).DisplayFormat := 'dd/mm/yyyy';  // o formato poderia, também, ser 'dd-mm-yy hh:mm:ss'
  TNumericField(frm_dm_movimentos.SQLQ_movimentos_CGD.FieldByName('data_mov')).EditMask := '!99/99/9999';

  TNumericField(frm_dm_movimentos.SQLQ_movimentos_CGD.FieldByName('data_valor')).DisplayFormat := 'dd/mm/yyyy';  // o formato poderia, também, ser 'dd-mm-yy hh:mm:ss'
  TNumericField(frm_dm_movimentos.SQLQ_movimentos_CGD.FieldByName('data_valor')).EditMask := '!99/99/9999';

// a máscara (editmask) foi definida no query
//funciona  TStringField(frm_dm_movimentos.SQLQ_movimentos1.FieldByName('descricao')).EditMask := '>aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa;0;_';

  frm_dm_movimentos.SQLQ_total_movimentos_CGD.Refresh;    //refresca a contagem do total de movimentos na BD

  with frm_dm_movimentos do
  begin
    if frm_dm_movimentos.SQLQ_totais_debito_credito_cgd.Active = FALSE then
       frm_dm_movimentos.SQLQ_totais_debito_credito_cgd.Active := TRUE;

    DBE_debito.DataSource := frm_dm_movimentos.DS_totais_debito_credito_cgd;
    DBE_debito.DataField := 'debito';

    DBE_credito.DataSource := frm_dm_movimentos.DS_totais_debito_credito_cgd;
    DBE_credito.DataField := 'credito';

    if frm_dm_movimentos.SQLQ_movimentos_CGD.Active = FALSE then
       frm_dm_movimentos.SQLQ_movimentos_CGD.Active := TRUE;

    if frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active = FALSE then
       frm_dm_movimentos.SQLQ_total_movimentos_CGD.Active := TRUE;
  end;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.SB_ExitClick(Sender: TObject);
begin
  Close;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.SB_Inverte_a_OrdemClick(Sender: TObject);
begin
  if Ordem_Movimentos = 'ASC' then Ordem_Movimentos := 'DESC'
  else
  if Ordem_Movimentos = 'DESC' then Ordem_Movimentos := 'ASC';

  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := FALSE;
  frm_dm_movimentos.SQLQ_movimentos_CGD.SQL.Text := 'select * from sch_conta.movimentos_cgd order by data_mov ' + Ordem_Movimentos;
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := TRUE;
end;
//-----------------------------------------------------------------------------------------------

procedure Tfrm_edita_cgd_movimentos.SB_PrepQueryClick(Sender: TObject);
begin
  frm_prep_query_cgd_movimentos.show;
  with frm_prep_query_cgd_movimentos do
  begin
    E_saldo_contabilistico.visible := TRUE;
    E_data_valor.visible := TRUE;
    E_credito.visible := TRUE;
    E_descricao.visible := TRUE;
    E_debito.visible := TRUE;
    E_PK_movimento.visible := TRUE;
    E_data_mov.visible := TRUE;
    E_saldo_disponivel.visible := TRUE;
    E_categoria.visible := TRUE;
    E_cod_tipo_movimento.Visible := TRUE;
    E_analisado.visible := TRUE;
//
    L_saldo_contabilistico.visible := TRUE;
    L_data_valor.visible := TRUE;
    L_credito.visible := TRUE;
    L_descricao.visible := TRUE;
    L_debito.visible := TRUE;
    L_PK_movimento.visible := TRUE;
    L_data_mov.visible := TRUE;
    L_saldo_disponivel.visible := TRUE;
    L_categoria.visible := TRUE;
    L_cod_tipo_movimento.Visible := TRUE;
    L_analisado.visible := TRUE;
  end;
end;

end.
